{-# LANGUAGE GADTs                 #-}
{-# LANGUAGE DataKinds             #-}
{-# LANGUAGE TypeFamilies          #-}
{-# LANGUAGE TypeOperators         #-}
{-# LANGUAGE StandaloneDeriving    #-}
{-# LANGUAGE ScopedTypeVariables   #-}
{-# LANGUAGE UndecidableInstances  #-}
{-# LANGUAGE TemplateHaskell       #-}
{-# LANGUAGE QuasiQuotes           #-}
{-# LANGUAGE PolyKinds             #-}
{-# LANGUAGE UnicodeSyntax         #-}

-- | Defines the boolean type and logical operators
module Data.Bool where

import Data.TypeClass (Eq, Enum, Show)
import Data.Singletons.TH
import Data.Singletons.Prelude.Enum


singletons [d|

  -- | Boolean Type
  data 𝔹 ∷ ★ where
    T ∷ 𝔹 -- ^ True
    F ∷ 𝔹 -- ^ False
    deriving (Eq, Show)


  -- * Logical operatos

  -- | Conjuction
  (∧) ∷ 𝔹 → 𝔹 → 𝔹
  T ∧ T = T
  _ ∧ F = F
  F ∧ _ = F
  
  -- | Disjuction
  (∨) ∷ 𝔹 → 𝔹 → 𝔹
  T ∨ _ = T
  _ ∨ T = T
  F ∨ F = F

  -- | Negation
  (¬) ∷ 𝔹 → 𝔹
  (¬) T = F
  (¬) F = T

  |]

